#include <U8g2lib.h>			// Library für die Ausgabe am LCD. Geniale Library für eine Vielzahl an LCDs
								// Quelle: https://github.com/olikraus/u8g2
#include <ESP8266WiFi.h>		// Library für den WLAN-Zugang für den Mini
#include <WiFiUdp.h>
#include <time.h>				// Library zur Verarbeitung der Zeit vom NTP-Server
#include <NTPClient.h>			// Alles für den NTP-Client
	#ifdef U8X8_HAVE_HW_SPI		// Je nach LCD hier HW anzugeben, vgl. Ausführungen von olikraus...
	#include <SPI.h>
	#endif
	#ifdef U8X8_HAVE_HW_I2C
	#include <Wire.h>
	#endif

U8G2_ST7567_JLX12864_F_SW_I2C u8g2(U8G2_R0, /* clock= */ 5, /* data= */ 4, /* reset=*/ U8X8_PIN_NONE); 
  // eingesetzter LCD: https://www.aliexpress.com/item/1005004237282931.html (12864 IIC 4P LCD Module 128X64 I2C ST7567S COG Graphic Display Screen Board LCM Panel 128x64 Dot Matrix Screen for Arduino)
  // Treiber: zur Library s. https://github.com/olikraus/u8g2/issues/1935
WiFiUDP ntpUDP;
// You can specify the time server pool and the offset (in seconds, can be
// changed later with setTimeOffset() ). Additionaly you can specify the
// update interval (in milliseconds, can be changed using setUpdateInterval() ).
// war NTPClient timeClient(ntpUDP, "europe.pool.ntp.org", 3600, 60000);
// Quelle: https://forum.arduino.cc/t/wie-ntpclient-timeclient-ntp-server-spater-im-setup-teil-definieren/691028
NTPClient timeClient(ntpUDP, "192.168.178.1", 3600, 60000);      // war "192.53.103.108", a.k.a. pool.ntp.org, hier wird die hemische fritzbox angesprochen, die 
#define udpPort 123

#define zeitLetzteZeitueberpruefung 300000 		// Jede 300 Sekunden neue Zeit beim NTP-Server abholen 
#define anzeigedauer 10000						// 10 Sekunden für die Anzeigedauer
boolean connected=0;
long zeitSeitLetztemUpdate = 0;
long zeitLetzteAnzeige = 0;						// Zeit seit letzter Anzeige

int randNumber=0;	      						// hier kommen die Zufallszahlen rein
int vorzeichen=0;
int teiler[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 	// teiler[0] iat die Anzahl der Teiler 
int tempi=0;									// temp-Variable 1 
int tempii=0;									// temp-Variable 1 
int level=5;									// Es geht mit Level 5 los ---- überflüssig???????

int currentDay=0;								// Welcher Tag des Monats
int currentMonth=0;								// Monat
int currentYear=0;								// Jahr

const char* networkName = "SSID";		// Access-Point-SSID
const char* networkPswd = "PASSWORD";							  // dazugehörendes Passwort
IPAddress ipadr;												    // Eine IP-Adresse kriegen wir auch

char myIpString[17];												// die Zahlen sollen zu Text (String) umgewandelt werden
char zeitString[9];
char stdString[10];
char minString[10];
char ausgabe[25];                         		// 20 oder 25?

char checkStdString[20];
char checkMinString[20];

void setup() {									// Wird einmalig nach dem Start des Esp8266 durchlaufen.
  Serial.begin(115200);							// Serielle Kommunikation ermöglichen 
  delay(10);
  u8g2.setI2CAddress (0x3F * 2);    			// darauf muss man kommen
  u8g2.begin();									// LCD initiieren
  u8g2.setContrast (130);           			// wichtig, sonst arg grell 
  u8g2.clearBuffer ();
            												// Verbindung zum WLAN, Standardroutine
    Serial.println();
    Serial.println();
    Serial.print("Connecting to ");
    Serial.println(networkName);
    WiFi.begin(networkName, networkPswd);					// Zugangsdaten mitteilen
    while (WiFi.status() != WL_CONNECTED) {
        delay(500);
        Serial.print(".");
    }
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
    ipadr = WiFi.localIP();
    sprintf(myIpString, "%d.%d.%d.%d", ipadr[0], ipadr[1], ipadr[2], ipadr[3]);	// Die IP-Adresse wird in einen String umgewandelt.

    timeClient.begin();							// fuer den NTP-Server
    timeClient.update();
    
  eingangsschirm();								// Willkommensschirm
  delay(5000);
}                                 				// Ende des Setups

int get_stunde()
{
  return (timeClient.getHours()+(int)summertime_EU((int)currentYear,(int)currentMonth, (int)currentDay, (int)timeClient.getHours(), 1));
}

boolean summertime_EU(int year, byte month, byte day, byte hour, byte tzHours)
{ 								  // European Daylight Savings Time calculation by "jurs" for German Arduino Forum
						  		  // input parameters: "normal time" for year, month, day, hour and tzHours (0=UTC, 1=MEZ)
						  		  // return value: returns true during Daylight Saving Time, false otherwise
					  			  // Quelle: http://forum.arduino.cc/index.php?topic=172044.msg1278536#msg1278536
  if (month<3 || month>10) return false; 	// keine Sommerzeit in Jan, Feb, Nov, Dez
  if (month>3 && month<10) return true; 	// Sommerzeit in Apr, Mai, Jun, Jul, Aug, Sep
  if (month==3 && (hour + 24 * day)>=(1 + tzHours + 24*(31 - (5 * year /4 + 4) % 7)) || month==10 && (hour + 24 * day)<(1 + tzHours + 24*(31 - (5 * year /4 + 1) % 7))) 
    return true; 
  else 
    return false;
}

void eingangsschirm() {								// erscheint nach dem Start des Mikrokontrollers

  u8g2.clearBuffer();          					  	// Internen (Zwischen-) Speicher löschen
  u8g2.setFont(u8g2_font_5x7_tr); 					// Font auswählen
												    // war vorher: u8g2.setFont(u8g2_font_ncenB08_tr);
  u8g2.drawStr(0,10,"Hallo Doglover 8D!");  		// zuerst in den Zwischenspeicher schreiben  
  u8g2.drawStr(0,20,"Deine IP-Adresse lautet:");  	// zuerst in den Zwischenspeicher schreiben 
  u8g2.drawStr(0,30,myIpString);  				    // zuerst in den Zwischenspeicher schreiben 

  u8g2.setFont(u8g2_font_fur14_tf); 				        	// Font auswählen für den weiteren Text
  sprintf(zeitString, "%02d:%02d:%02d", get_stunde(), timeClient.getMinutes(), timeClient.getSeconds());

  u8g2.drawStr(0,50,"Zeit: ");  					          	// zuerst in den Zwischenspeicher schreiben 
  u8g2.drawStr(50,50,zeitString);  					        	// zuerst in den Zwischenspeicher schreiben 

  u8g2.sendBuffer();          						          	// und jetzt den ganzen Krempel vom Zwischenspeiocher auf das Display schreiben
}

void faktorenBestimmen(int zahl){
															// Faktoren bestimmen und ni Array ablegen
															// ? int zaehler=0;
	teiler[0]=0;
	int max=(int)sqrt(zahl);    							// es müssen ja nicht alle Zahlen durchgetestet werden!
	for (int i=1;i<=max;i++)
	{
		if(zahl%i==0)
		{
			teiler[0]++;
			teiler[teiler[0]]=i;
			teiler[0]++;									// auffüllen
			teiler[teiler[0]]=zahl/i;						// auffüllen
			if (teiler[teiler[0]]==teiler[teiler[0]-1])		// fuer den Fall einer Quadratzahl reicht ein Faktor
				teiler[0]--;
		}
	}
															// Faktoren nacheinander auf dem ser. Monitor ausgeben
	Serial.print("Variable ist: ");
	Serial.print(zahl);
	Serial.print(". Anzahl der Teiler mit nachf. Teilern ");
	for(int i=0;i<=teiler[0];i++)
	{
		Serial.print(teiler[i]);
		Serial.print(", ");  
	}
	Serial.println(" Das war's!");
}	

int faktorAuswaehlen() {
		tempii=teiler[random(1, teiler[0]+1)];				// einen zufälligen Faktor auswählen (in teiler[0] steht die Anzahl der Teiler)  
															// müsste es nicht +2 heißen?
		Serial.print("Ausgewählter Faktor: ");
		Serial.println(tempii);
		return tempii;
}

void zeitkodiertAusgeben() {
														     // Berechnung und Speicherung in Stings
   randomSeed(analogRead(1)); 						         // Neues Zufallszahlen-Set ansetzen
   sprintf(ausgabe, "Current time (Level %d): ",level);      // ERSTE ZEILE ausgeben

   switch(level)                                                                                                  
	{
	case 1:                                                                              
	{	// LEVEL 1 ZWEITE ZEILE: Stunde
	
		// zuerst wird festgelegt, ob der Nutzer addieren oder subtrahieren soll
	    
		vorzeichen = random(1,3);    					// lege das Vorzeichen fest, 1=plus, 2=minus
        if(vorzeichen==1)   	// +++++Addieren
		{
			if(get_stunde()>9)
				{
					randNumber = random(0,10);    				// bestimme Zufallszahl von 0 (inkl.) bis 10 (exkl.), nicht zu schwer
					Serial.println(randNumber);          
				}
			else
				{
					randNumber = random(0,(get_stunde()+1));    // bestimme Zufallszahl bei Std. kleiner als 9
					Serial.println(randNumber);                                       
				}

			if(random(0,2)==0)		// beide Summanden zufällig mischen, bei kleinen Zahlen wird es sonst langweilig
				{					// und gleich in den String
					sprintf(stdString, "%d+%d h", get_stunde()-randNumber, randNumber);	
				}
			else
				{
					sprintf(stdString, "%d+%d h", randNumber, get_stunde()-randNumber);
				}
		}
        else            		// ------ Subtrahieren
			{
				randNumber = random(0,10);    				// bestimme Zufallszahl von 0 (inkl.) bis 10 (exkl.)
				Serial.print("-");
				Serial.println(randNumber);          
				sprintf(stdString, "%d-%d h", get_stunde()+randNumber, randNumber); 	// wir machen es nicht zu schwer

			}

		// LEVEL 1 DRITTE Zeile: Minuten

		// zuerst wird wieder festgelegt, ob der Nutzer addieren oder subtrahieren soll
        vorzeichen = random(1,3);    // lege das Vorzeichen fest, 1=plus, 2=minus                                     

        if(vorzeichen==1)   // +++++ Addieren
        {
          if(timeClient.getMinutes()>9)
			{
				randNumber = random(0,10);    				// bestimme Zufallszahl von 0 (inkl.) bis 10 (exkl.), nicht zu schwer
				Serial.println(randNumber);          
			}
          else
            {
				randNumber = random(0,(timeClient.getMinutes()+1)); // bestimme Zufallszahl bei Min kleiner als 9
				Serial.println(randNumber);                                       
            }
          sprintf(minString, "%d+%d m", timeClient.getMinutes()-randNumber, randNumber);                                        
        }
        else            // ----- Subtrahieren
        {
				randNumber = random(0,10);    				// bestimme Zufallszahl von 0 (inkl.) bis 10 (exkl.), nicht zu schwer
				Serial.print("-");
				Serial.println(randNumber);          
				sprintf(minString, "%d-%d m", timeClient.getMinutes()+randNumber, randNumber);                                        
        }
		break;
	}
    case 2:
	{ 	// LEVEL 2 ZWEITE ZEILE: Stunde

		// zuerst wird festgelegt, ob der Nutzer addieren oder subtrahieren soll
		
		vorzeichen = random(1,3);    	// lege das Vorzeichen fest, 1=plus, 2=minus
		if(vorzeichen==1)   			// +++++ Addieren  
		{
			randNumber = random(0,get_stunde()+1); // Zufallszahl zwischen 0 und Stunde (inkl.)                                       
			Serial.println(randNumber);          
			sprintf(stdString, "%d+%d h", get_stunde()-randNumber, randNumber);                                        
		}
		else            				// ----- Subtrahieren
		{
			randNumber = random(10,(100-get_stunde())); 	// Zufallszahl ab 10; damit es nicht zu einfach wird, größere Zahl als Subtrahend
															// ist hier +1 zu nehmen??? Oder ist die Null zu einfach? Egal
			Serial.print("-");
			Serial.println(randNumber);          
			sprintf(stdString, "%d-%d h", get_stunde()+randNumber, randNumber);                                        
		}

		// LEVEL 2 DRITTE ZEILE: Minuten
			
		vorzeichen = random(1,3);    	// lege das Vorzeichen fest, 1=plus, 2=minus                                    
		if(vorzeichen==1)   			// +++++ Addieren
		{
			randNumber = random(0,timeClient.getMinutes()+1); 		// Zufallszahl zwischen 0 und Minuten (inkl.)
			Serial.println(randNumber);          
			sprintf(minString, "%d+%d m", timeClient.getMinutes()-randNumber, randNumber);                                        
		}
		else            				// ----- Subtrahieren
		{
			randNumber = random(10,(100-timeClient.getMinutes())); // damit es nicht zu einfach wird, Differenz größer 10
			Serial.print("-");
			Serial.println(randNumber);          
			sprintf(minString, "%d-%d m", timeClient.getMinutes()+randNumber, randNumber);                                        
		}
		break;
	}
    case 3:
	{ 
		// Level 3 ZWEITE ZEILE: Stunde, Es wird immer addiert werden. 

			randNumber = random(10,(100-get_stunde())); 			// print a random number from 0 (inkl.) to hh (inkl.)                                       
			Serial.println(randNumber);          
			sprintf(stdString, "-%d+%d h", randNumber, get_stunde()+randNumber);

		// LEVEL 3 DRITTE ZEILE: Minuten
			
			randNumber = random(10,(100-timeClient.getMinutes())); 	// eine zufällige, ausreichend große Zahl                                        
			Serial.println(randNumber);          
			sprintf(minString, "-%d+%d m", randNumber, timeClient.getMinutes()+randNumber);                                        
		break;
	}
    case 4:
	{
		// Level 4 ZWEITE ZEILE: Stunde, Vorzeichen sind immer PLUS

		if (get_stunde()==0)										// hier muß Division durch 0 verhindert werden
		{
			if(random(0,2)==1)										// hier wird multipliziert...
			{
				tempi=random(0,100);
				if(random(0,2)==1)									// 0 einmal vorne, einmal hinten
				{
					sprintf(stdString, "%d*%d h", tempi, get_stunde());
					Serial.print("L4.H.Div0.Mult.Z1 ");
					Serial.println(tempi);
				}
				else
				{
					sprintf(stdString, "%d*%d h", get_stunde(), tempi);
					Serial.print("L4.H.Div0.Mult.Z2 ");
					Serial.println(tempi);
				}
			}
			else													// ... oder dividiert
			{
				tempi=random(0,100);
				Serial.print("L4.H.Div0.Divi ");
				Serial.println(tempi);
				sprintf(stdString, "%d:%d h", get_stunde(), tempi);		
			}
		}
		else														// hier findet keine Div durch 0 statt!
		{
			if(random(0,2)==1)										// hier wird multipliziert
			{
				faktorenBestimmen(get_stunde());
				tempi=faktorAuswaehlen(); 							// hier ist keine zufällige Mischung der Faktoren erforderlich
				Serial.print("L4.H.keineDiv0.Multi ");
				Serial.println(tempi);
				sprintf(stdString, "%d*%d h", tempi, get_stunde()/tempi);
			}
			else													// hier wird dividiert
			{
				tempi=random(1, ((int)(99/get_stunde())));
				Serial.print("L4.H.keineDiv0.Divi ");
				Serial.println(tempi);
				sprintf(stdString, "%d:%d h", get_stunde()*tempi, tempi);
			}
		}
		
		// Level 4 Dritte ZEILE: Minute, Vorzeichen sind immer PLUS

		if (timeClient.getMinutes()==0)		// um Div by Zero vorzubeugen
		{
			if(random(0,2)==1)				// hier wird multipliziert...
			{
				tempi=random(0,100);
				if(random(0,2)==1)			// 0 einmal vorne, einmal hinten
				{
					sprintf(minString, "%d*%d m", tempi, timeClient.getMinutes());
					Serial.print("L4.M.Div0.Multi.Z1 ");Serial.println(tempi);
				}
				else
				{
					sprintf(minString, "%d*%d m", timeClient.getMinutes(), tempi);
					Serial.print("L4.M.Div0.Multi.Z2 ");Serial.println(tempi);
				}
			}
			else							// ... oder dividiert
			{
				tempi=random(0,100);
				Serial.print("L4.M.Div0.Divi ");Serial.println(tempi);
				sprintf(minString, "%d:%d m", timeClient.getMinutes(), tempi);		
			}
		}
		else								// hier findet keine Div by Zero statt.
		{
			if(random(0,2)==1)				// hier wird multipliziert
			{
				faktorenBestimmen(timeClient.getMinutes());
				tempi=faktorAuswaehlen();		// hier ist keine zufäll. Anordnung der Faktoren erforderlich
				Serial.print("L4.M.keineDiv0.Multi ");Serial.println(tempi);
				sprintf(minString, "%d*%d m", tempi, timeClient.getMinutes()/tempi);	
			}
			else							// hier wird dividiert
			{
				tempi=random(1, (int)(99/timeClient.getMinutes()));
				Serial.print("L4.M.keineDiv0.Divi ");Serial.println(tempi);
				sprintf(minString, "%d:%d m", timeClient.getMinutes()*tempi, tempi);
			}
		}
	break;
	}
	case 5:
	{
		if(random(0,2)==1)				// Level 5 ZWEITE ZEILE: Stunde, Multiplikation
		{
			tempi=random(0,10);
			tempii=random(0,10);
			Serial.print("L5.H.Sub.Faktor1 ");Serial.println(tempi);
			Serial.print("L5.H.Sub.Faktor2 ");Serial.println(tempii);
			if(tempi*tempii>get_stunde())
			{
				sprintf(stdString, "%d-%d*%d h", get_stunde()+tempi*tempii, tempi, tempii);
				sprintf(checkStdString, "%d ----- %d h", get_stunde(), get_stunde()+tempi*tempii-tempi*tempii);
			}
			else
			{
				if (random(0,2)==1)
				{
					sprintf(stdString, "%d+%d*%d h", get_stunde()-tempi*tempii, tempi, tempii);
					sprintf(checkStdString, "%d ----- %d h",get_stunde(), get_stunde()-tempi*tempii+tempi*tempii);
				}
				else
				{
					sprintf(stdString, "%d*%d+%d h", tempi, tempii, get_stunde()-tempi*tempii);
					sprintf(checkStdString, "%d ----- %d h",get_stunde(),tempi*tempii+get_stunde()-tempi*tempii);
				}
			}
		}
		else							// Level 5 ZWEITE ZEILE: Stunde, Div
		{
			tempii=random(0,10);
			tempi=random(1,10);
			Serial.print("L5.H.Div.q2 ");Serial.println(tempi);
			Serial.print("L5.H.Div.c ");Serial.println(tempii);
			if(get_stunde()>tempii)		// q1:tempi+tempii=std
			{										   
														// Std=(get_stunde()-tempii)*tempi
				if(random(0,2)==1)				// Summanden zufällig tauschen
				{
					sprintf(stdString, "%d:%d+%d h", (get_stunde()-tempii)*tempi, tempi, tempii);
					sprintf(checkStdString, "%d ----- %d h",get_stunde(),(get_stunde()-tempii)*tempi/tempi+tempii);
				}
				else
				{
					sprintf(stdString, "%d+%d:%d h", tempii, (get_stunde()-tempii)*tempi, tempi);
					sprintf(checkStdString, "%d ----- %d h",get_stunde(),tempii+(get_stunde()-tempii)*tempi/tempi);
				}
			}
			else
			{				// Summanden braucht man hier wegen der Subtr nicht zufällig zu tauschen
				
					sprintf(stdString, "%d:%d-%d h", (get_stunde()+tempii)*tempi, tempi, tempii);
					sprintf(checkStdString, "%d ----- %d h",get_stunde(),(get_stunde()+tempii)*tempi/tempi-tempii);
			}
		}

// Level 5 DRITTE ZEILE: Minutn

	if(random(0,2)==1)				// Level 5 ZWEITE ZEILE: Min, Multiplikation
	{
		tempi=random(0,10);
		tempii=random(0,10);
		Serial.print("L5.M.Sub.Faktor1 ");Serial.println(tempi);
		Serial.print("L5.M.Sub.Faktor2 ");Serial.println(tempii);
		if(tempi*tempii>timeClient.getMinutes())
		{
			sprintf(minString, "%d-%d*%d m", timeClient.getMinutes()+tempi*tempii, tempi, tempii);
			sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(), timeClient.getMinutes()+tempi*tempii-tempi*tempii);
		}
		else
		{
			if (random(0,2)==1)
			{
				sprintf(minString, "%d+%d*%d m", timeClient.getMinutes()-tempi*tempii, tempi, tempii);
				sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(),timeClient.getMinutes()-tempi*tempii+tempi*tempii);
			}
			else
			{
				sprintf(minString, "%d*%d+%d M-", tempi, tempii, timeClient.getMinutes()-tempi*tempii);
				sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(),tempi*tempii+timeClient.getMinutes()-tempi*tempii);
			}
		}
	}
	else							// Level 5 ZWEITE ZEILE: Min, Div
	{
		tempii=random(0,10);
		tempi=random(1,10);
		Serial.print("L5.M.Div.q2 ");Serial.println(tempi);
		Serial.print("L5.M.Div.c ");Serial.println(tempii);
		if(timeClient.getMinutes()>tempii)		                            	// q1:tempi+tempii=Min
		{		
												                                // q1=(timeClient.getMinutes()-tempii)*tempi
			if(random(0,2)==1)			                                      	// Summanden zufällig tauschen
			{
				sprintf(minString, "%d:%d+%d m", (timeClient.getMinutes()-tempii)*tempi, tempi, tempii);
				sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(),(timeClient.getMinutes()-tempii)*tempi/tempi+tempii);
			}
			else
			{
				sprintf(minString, "%d+%d:%d M", tempii, (timeClient.getMinutes()-tempii)*tempi, tempi);
				sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(),tempii+(timeClient.getMinutes()-tempii)*tempi/tempi);
			}
		}
		else
		{
			                                                                // if(random(0,2)==1)				// Summanden zufällig tauschen
			{
				sprintf(minString, "%d:%d-%d m", (timeClient.getMinutes()+tempii)*tempi, tempi, tempii);
				sprintf(checkMinString, "%d ----- %d m", timeClient.getMinutes(),(timeClient.getMinutes()+tempii)*tempi/tempi-tempii);
			}
		}
	}
			
	break;
	}
	default:
  break;     // kein Default-Exit  
}
											// Ausgabe der Strings
											
   u8g2.clearBuffer();                		// Zwischenspeicher loeschen

   u8g2.setFont(u8g2_font_5x7_tr); 		    // Font auswaehlen
   u8g2.drawStr(0,10,ausgabe);            	// Ausgabe der ersten Zeile
   u8g2.setFont(u8g2_font_helvB18_tr);
   u8g2.drawStr(0, 33, stdString);        	// Ausgabe der zweiten Zeile
   u8g2.drawStr(0, 57, minString);        	// Ausgabe der dritten Zeile

   u8g2.sendBuffer();                       // transfer internal memory to the display

// test
	Serial.println(checkStdString);
	Serial.println(checkMinString);

   // Sicherstellen, dass beim Testbetrieb kein alter String versehentlich für richtig wahrgenommen wird
		Serial.println(stdString);
		Serial.println(minString);
    sprintf(stdString, " ");   
	sprintf(minString, " ");   
	sprintf(ausgabe, " ");   
	sprintf(checkStdString, " ");   
	sprintf(checkMinString, " ");   
   
   level--;							      	// Level setzen, ein weniger
   if (level<1) 							// wenn der Zähler wieder unter 1 kommt  
    {
	    	level=5; 						// es geht wieder von vorne los
    } 
}

void loop() {
														          				// Ausgabe der Zeit jede o. definierte Sekunden
 if (millis() - zeitLetzteAnzeige > anzeigedauer) 
    {
        zeitkodiertAusgeben();
        zeitLetzteAnzeige = millis();
    }
													        					// Aktualisierung der Zeit jede o. definierte Sekunden
  if (millis() - zeitSeitLetztemUpdate > zeitLetzteZeitueberpruefung) 			// Update vom NTP-Server erforderlich?
    {
    timeClient.update();
    Serial.print("Aktuelle Zeit: ");
    Serial.println(timeClient.getFormattedTime()); 								// Ausgabe der Zeit zur Prüfung auf der Konsole
																                // Kalkulation der Jahre, Monate und des Tages aus dem Datum, 
																	            // Quelle: https://randomnerdtutorials.com/esp8266-nodemcu-date-time-ntp-client-server-arduino/
    time_t epochTime = timeClient.getEpochTime();
    struct tm *ptm = gmtime ((time_t *)&epochTime);  
    currentDay = ptm->tm_mday;
    currentMonth = ptm->tm_mon+1;									  	// Jan=0, Feb=1 etc.
    currentYear = ptm->tm_year+1900;									// Unix-Zeitrechnung ab 1900, hahahaha
													                  	// Ausgabe NTP-Zeit
	Serial.print("Ausgabe NTP-Zeit: ");
	Serial.println((int)summertime_EU((int)currentYear,(int)currentMonth, (int)currentDay, (int)timeClient.getHours(), 1));		// here comes the time, shoobeedooh
	Serial.print("Ausgabe NTP-Zeit: Jahr, Monat, Tag, Std.");

	Serial.print((int)currentYear);Serial.print(" ");
	Serial.print((int)currentMonth);Serial.print(" ");
	Serial.print((int)currentDay);Serial.print(" ");
	Serial.println((int)timeClient.getHours());Serial.print(" ");
  
    zeitSeitLetztemUpdate = millis();									// 
    }
}

/*
Level 1: 	Addieren und Subtrahieren mit Zahlen bis 10, Keine negativen Zahlen
			
Level 2:	Addieren und Subtrahieren mit Zahlen bis 100
			Keine negativen Zahlen

Level 3:	Immer addieren, aber eine negative Zahl ist immer dabei
			zumind. eine Zahl ist größer als 10

Level 4:	Multiplizieren und Dividieren

Level 5:	Multiplizieren und Dividieren, Addieren und Subtrahieren, Punkt- vor Strichrechnung zu beachten

*/
